# frozen_string_literal: true
# typed: true

module ApiGenerator
  class Url
    extend T::Sig

    attr_reader :url

    sig { params(url: String).void }

    def initialize(url)
      @url = url
    end

    sig { params(method: Symbol, args: T.untyped, block: T.nilable(T.proc.void)).returns(T.self_type) }
    def method_missing(method, *args, &block)
     ApiGenerator::Url.new(File.join(url, method))
    end
  end
end